
(* NCControl.m -
		Allows one to use Bakshee's Control System Professional package.
*)


(* 
sys1 = StateSpace[ {{a1,a2},{a3,a4}},{{b1},{b2}},{{c1,c2}},{{d}} ];
sys2 = StateSpace[ {{u1,u2},{u3,u4}},{{v1},{v2}},{{w1,w2}},{{z}} ];

(*************   BEGIN BAKSHEE  ************************)
(**********    These functions are needed to run Bakshee stuff *)
(* Need  to bring the package in with a call to a function in it **)
SeriesConnect[ sys1, sys2 ];

TransferFunction[ s, sys1 ];
*)

BeginPackage[ "NCControl`", "ControlSystems`Common`", 
                              "ControlSystems`Connections`" ];

(***** The functions ****)
DownValues[ControlSystems`Connections`Private`feedback] =
  DownValues[ControlSystems`Connections`Private`feedback] /.
    {Inverse -> NCConnectInverse,
      Dot[f_, s_, th_] -> NCMatMult`MatMult[NCMatMult`MatMult[f, s], th]};


DownValues[TransferFunction] =
  DownValues[TransferFunction] /.
    {Inverse -> NCConnectInverse,
      Dot[f_, s_, th_] -> NCMatMult`MatMult[NCMatMult`MatMult[f, s], th]};

DownValues[ControlSystems`Common`TransferFunction] =
  DownValues[ControlSystems`Common`TransferFunction] /.
    {ControlSystems`Common`Private`inverse -> NCConnectInverse,
      ControlSystems`Common`Private`dot -> NCMatMult`MatMult };

NCConnectInverse := NCInverse ;

(**************  END BAKSHEE ********)

(*  Dells add ons **) 
(*  Bakshee calls it dual **)
NCConjugateSystem[ ncs_StateSpace] := Module[ {newSys},

newSys =  StateSpace[  -tpMat[ncs[[1]] ] , -tpMat[ncs[[3]] ] ,
     tpMat[ncs[[2]] ], tpMat[ncs[[4]]] ];

 Return[newSys ];
]; (* end module - ConjugateSystem[] *)


NCInverseSystem[ ncs_StateSpace ] := Module[ {MyA },

MyA =      ncs[[1]] - MM[ ncs[[2]],
     NCConnectInverse[ ncs[[4]] ],  ncs[[3]] ] ;

newSys =  StateSpace[  MyA,
     - MM[ncs[[2]],  NCConnectInverse[ ncs[[4]] ]  ],
     MM[ NCConnectInverse[ ncs[[4]] ] , ncs[[3]]],  
NCConnectInverse[ ncs[[4]] ] ];

Return[ newSys ];
];

EndPackage[];
